// Compilation: clang++ main-aesend.cc -framework CoreServices -framework Carbon -o send_message_aesend
// Documentation: http://developer.apple.com/legacy/mac/library/#documentation/Carbon/Reference/Apple_Event_Manager/Reference/reference.html%23//apple_ref/doc/uid/TP30000134

#include <CoreServices/CoreServices.h>
#include <Carbon/Carbon.h>

int main (int argc, char const* argv[])
{
	char const* test_message = "From: Spammer\nTo: Non-spammer\n\nSpam, spam, and spam.\n";
	OSType signature = 'mtSS';
	OSType eventID = 'iSSc';

	AEAddressDesc target;
	AECreateDesc(typeApplSignature, &signature, sizeof(OSType), &target);

	AppleEvent appleEvent;
	AECreateAppleEvent(signature, eventID, &target, kAutoGenerateReturnID, kAnyTransactionID, &appleEvent);

	AEPutParamPtr(&appleEvent, 'Mess', 'TEXT', test_message, strlen(test_message));

	AppleEvent theReply;
	OSErr err = AESend(&appleEvent, &theReply, kAEWaitReply, kAENormalPriority, kAEDefaultTimeout, NULL, NULL);
	if(err != noErr)
			fprintf(stderr, "Failed to send message to SpamSieve: %d\n", (int)err);
	else	fprintf(stderr, "Successfully sent message to SpamSieve\n");

	return 0;
}
